#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <fcntl.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <termios.h>
#include <math.h>
#include <string.h>
#include <syslog.h>

#include "libipfwc.h"

#ifdef SHADOW
#include <shadow.h>
#else
#include <pwd.h>
#endif

#define OK        0
#define ERR      -1
#define MAXCON    5
#define MAXBUFF 255
#define MAXCON 0xffff
#define MAXTRY    2
#define TRUE      1
#define FALSE     0
#define PORT   6969

#define CONFIG_FILE "/etc/keyhole.conf"
#define INTERFACE "lo"
#define SEND_NL send(a,"\n",1,0)


/* Linked list of ip_fwuser, for resetting firewall on quit */

struct saved_ipfw
{
          struct saved_ipfw *next_ipfw;
          struct ip_fwuser ipfw;
};



struct cmd
{
          char *cmdname;
          int (*func) (char *port);
          char explain[MAXBUFF];
};


void fw_reset (void);
void endserver (int sig);
void reqctrl (void);
void setbits (short int bit, char updown, char *bitarray);
void msf (void);
void usage (char *argv);

int fwrise (char *port, char action);
int demonize (void);
int server (int port);
int list (char *nope);
int fwopen (char *port);
int fwclose (char *port);
int help (char *nope);
int fwshow (char *nope);
int quit (char *nope);


char *check_packet (ip_chainlabel chain, int *bit, struct ip_fwuser *fw);
struct ip_fwuser *build_packet (char action, unsigned long int saddr,
          unsigned long int daddr, unsigned short int *sbit,
          unsigned short int *dbit);
